﻿Imports System.Runtime.InteropServices
Imports System.ComponentModel
Imports System.Windows.Forms
Imports AddinExpress.MSO
Imports Excel = Microsoft.Office.Interop.Excel

'Add-in Express Add-in Module
<GuidAttribute("653861DF-A839-43A2-A2AB-7CF756FDA4DC"), ProgIdAttribute("adx_xl_vb_customEvent.AddinModule")> _
Public Class AddinModule
    Inherits AddinExpress.MSO.ADXAddinModule
    Private WithEvents adxRibbonCommandManual As AddinExpress.MSO.ADXRibbonCommand
    Private WithEvents adxRibbonCommandExceptTables As AddinExpress.MSO.ADXRibbonCommand
    Friend WithEvents adxExcelEvents As AddinExpress.MSO.ADXExcelAppEvents
    Private WithEvents adxRibbonCommandAutomatic As AddinExpress.MSO.ADXRibbonCommand
    Private WithEvents adxRibbonCommandOptionsDialog As AddinExpress.MSO.ADXRibbonCommand
    Private WithEvents adxBuiltInControlToolsOptions As AddinExpress.MSO.ADXBuiltInControl

    Private Const WM_USER As Integer = &H400
    Private cancelAction As Boolean = True
    Private currentCalculationMode As Object = Nothing

    ' Ribbon button
    Private WM_OptionAutomatic As Integer = WM_USER + 1001
    ' Ribbon button
    Private WM_OptionSemiAutomatic As Integer = WM_USER + 1002
    ' Ribbon button
    Private WM_OptionManual As Integer = WM_USER + 1003
    ' Options dialog (Ribbon)
    Private WM_RibbonOptions As Integer = WM_USER + 1004
    ' Options dialog (CommandBar)
    Private WM_CommandbarOptions As Integer = WM_USER + 1005



#Region " Component Designer generated code. "
    'Required by designer
    Private components As System.ComponentModel.IContainer
 
    'Required by designer - do not modify
    'the following method
    Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container()
        Me.adxBuiltInControlToolsOptions = New AddinExpress.MSO.ADXBuiltInControl(Me.components)
        Me.adxRibbonCommandOptionsDialog = New AddinExpress.MSO.ADXRibbonCommand(Me.components)
        Me.adxRibbonCommandAutomatic = New AddinExpress.MSO.ADXRibbonCommand(Me.components)
        Me.adxExcelEvents = New AddinExpress.MSO.ADXExcelAppEvents(Me.components)
        Me.adxRibbonCommandExceptTables = New AddinExpress.MSO.ADXRibbonCommand(Me.components)
        Me.adxRibbonCommandManual = New AddinExpress.MSO.ADXRibbonCommand(Me.components)
        '
        'adxBuiltInControlToolsOptions
        '
        Me.adxBuiltInControlToolsOptions.CommandBar = Nothing
        Me.adxBuiltInControlToolsOptions.ControlTag = "30b15ded-e6ef-4afd-bf49-820e7123ab91"
        Me.adxBuiltInControlToolsOptions.Id = 522
        '
        'adxRibbonCommandOptionsDialog
        '
        Me.adxRibbonCommandOptionsDialog.Id = "adxRibbonCommand_9bb217d6861f4ecc913107f51981cd85"
        Me.adxRibbonCommandOptionsDialog.IdMso = "ApplicationOptionsDialog"
        Me.adxRibbonCommandOptionsDialog.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'adxRibbonCommandAutomatic
        '
        Me.adxRibbonCommandAutomatic.ActionTarget = AddinExpress.MSO.ADXRibbonCommandTarget.ToggleButton
        Me.adxRibbonCommandAutomatic.Id = "adxRibbonCommand_8a31e6e55f78463ca53c14d2c68a85c8"
        Me.adxRibbonCommandAutomatic.IdMso = "CalculationOptionsAutomatically"
        Me.adxRibbonCommandAutomatic.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'adxExcelEvents
        '
        '
        'adxRibbonCommandExceptTables
        '
        Me.adxRibbonCommandExceptTables.ActionTarget = AddinExpress.MSO.ADXRibbonCommandTarget.ToggleButton
        Me.adxRibbonCommandExceptTables.Id = "adxRibbonCommand_f4826f22406447fca13f95ffc1f43d64"
        Me.adxRibbonCommandExceptTables.IdMso = "CalculationOptionsAutomaticallyExceptDataTables"
        Me.adxRibbonCommandExceptTables.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'adxRibbonCommandManual
        '
        Me.adxRibbonCommandManual.ActionTarget = AddinExpress.MSO.ADXRibbonCommandTarget.ToggleButton
        Me.adxRibbonCommandManual.Id = "adxRibbonCommand_7ffc4e34ef2c4ad2b4cf135bad083ea5"
        Me.adxRibbonCommandManual.IdMso = "CalculationOptionsManuallly"
        Me.adxRibbonCommandManual.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook
        '
        'AddinModule
        '
        Me.AddinName = "adx_xl_vb_customEvent"
        Me.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaExcel

    End Sub
 
#End Region
 
#Region " Add-in Express automatic code "
 
    'Required by Add-in Express - do not modify
    'the methods within this region
 
    Public Overrides Function GetContainer() As System.ComponentModel.IContainer
        If components Is Nothing Then
            components = New System.ComponentModel.Container
        End If
        GetContainer = components
    End Function
 
    <ComRegisterFunctionAttribute()> _
    Public Shared Sub AddinRegister(ByVal t As Type)
        AddinExpress.MSO.ADXAddinModule.ADXRegister(t)
    End Sub
 
    <ComUnregisterFunctionAttribute()> _
    Public Shared Sub AddinUnregister(ByVal t As Type)
        AddinExpress.MSO.ADXAddinModule.ADXUnregister(t)
    End Sub
 
    Public Overrides Sub UninstallControls()
        MyBase.UninstallControls()
    End Sub
 
#End Region
 
    Public Sub New()
        MyBase.New()
 
        Application.EnableVisualStyles()
        'This call is required by the Component Designer
        InitializeComponent()
 
        'Please add any initialization code to the AddinInitialize event handler
 
    End Sub

    Public Shared Shadows ReadOnly Property CurrentInstance() As AddinModule
        Get
            Return CType(AddinExpress.MSO.ADXAddinModule.CurrentInstance, AddinModule)
        End Get
    End Property

    Public ReadOnly Property ExcelApp() As Excel._Application
        Get
            Return CType(HostApplication, Excel._Application)
        End Get
    End Property

    Private Sub adxBuiltInControlToolsOptions_ActionEx(sender As System.Object, e As AddinExpress.MSO.ADXCancelEventArgs) Handles adxBuiltInControlToolsOptions.ActionEx
        e.Cancel = cancelAction
        System.Diagnostics.Debug.Print("Tools|Options cancelAction=" + cancelAction.ToString())
        If (cancelAction) Then
            Me.SendMessage(WM_CommandbarOptions) 'see AddinModule_OnSendMessage
        End If
    End Sub

    Private Sub adxRibbonCommandOptionsDialog_OnAction(sender As System.Object, control As AddinExpress.MSO.IRibbonControl, pressed As System.Boolean, e As AddinExpress.MSO.ADXCancelEventArgs) Handles adxRibbonCommandOptionsDialog.OnAction
        e.Cancel = cancelAction
        System.Diagnostics.Debug.Print("ApplicationOptionsDialog cancelAction=" + cancelAction.ToString())
        If (cancelAction) Then
            Me.SendMessage(WM_RibbonOptions) 'see AddinModule_OnSendMessage
        End If
    End Sub

    Private Sub adxRibbonCommandAutomatic_OnAction(sender As System.Object, control As AddinExpress.MSO.IRibbonControl, pressed As System.Boolean, e As AddinExpress.MSO.ADXCancelEventArgs) Handles adxRibbonCommandAutomatic.OnAction
        e.Cancel = cancelAction
        System.Diagnostics.Debug.Print("adxRibbonCommandAutomatic_OnAction cancelAction=" + cancelAction.ToString())
        If (cancelAction) Then
            Me.SendMessage(WM_OptionAutomatic) 'see AddinModule_OnSendMessage
        End If
    End Sub

    Private Sub adxRibbonCommandExceptTables_OnAction(sender As System.Object, control As AddinExpress.MSO.IRibbonControl, pressed As System.Boolean, e As AddinExpress.MSO.ADXCancelEventArgs) Handles adxRibbonCommandExceptTables.OnAction
        e.Cancel = cancelAction
        System.Diagnostics.Debug.Print("adxRibbonCommandExceptTables_OnAction cancelAction=" + cancelAction.ToString())
        If (cancelAction) Then
            Me.SendMessage(WM_OptionSemiAutomatic) 'see AddinModule_OnSendMessage
        End If
    End Sub

    Private Sub adxRibbonCommandManual_OnAction(sender As System.Object, control As AddinExpress.MSO.IRibbonControl, pressed As System.Boolean, e As AddinExpress.MSO.ADXCancelEventArgs) Handles adxRibbonCommandManual.OnAction
        e.Cancel = cancelAction
        System.Diagnostics.Debug.Print("adxRibbonCommandManual_OnAction cancelAction=" + cancelAction.ToString())
        If (cancelAction) Then
            Me.SendMessage(WM_OptionManual) 'see AddinModule_OnSendMessage
        End If
    End Sub

    Private Sub AddinModule_AddinInitialize(sender As System.Object, e As System.EventArgs) Handles MyBase.AddinInitialize
        currentCalculationMode = ExcelApp.Calculation
        System.Diagnostics.Debug.Print("AddinModule_AddinInitialize. currentCalculationMode=" + currentCalculationMode.ToString())
    End Sub

    Private Sub adxExcelEvents_WorkbookOpen(sender As System.Object, hostObj As System.Object) Handles adxExcelEvents.WorkbookOpen
        currentCalculationMode = ExcelApp.Calculation
        System.Diagnostics.Debug.Print("adxExcelEvents_WorkbookOpen. currentCalculationMode=" + currentCalculationMode.ToString())
    End Sub

    Private Sub AddinModule_OnSendMessage(sender As System.Object, e As AddinExpress.MSO.ADXSendMessageEventArgs) Handles MyBase.OnSendMessage
        If (e.Message = WM_OptionAutomatic) Then
            System.Diagnostics.Debug.Print("AddinModule_OnSendMessage. WM_OptionAutomatic")
            cancelAction = False
            Me.CommandBarsObj.GetType().InvokeMember("ExecuteMso", System.Reflection.BindingFlags.InvokeMethod, Nothing, Me.CommandBarsObj, New Object() {"CalculationOptionsAutomatically"})
            CheckCalculationMode()
            cancelAction = True
        ElseIf (e.Message = WM_OptionSemiAutomatic) Then
            System.Diagnostics.Debug.Print("AddinModule_OnSendMessage. WM_OptionSemiAutomatic")
            cancelAction = False
            Me.CommandBarsObj.GetType().InvokeMember("ExecuteMso", System.Reflection.BindingFlags.InvokeMethod, Nothing, Me.CommandBarsObj, New Object() {"CalculationOptionsAutomaticallyExceptDataTables"})
            CheckCalculationMode()
            cancelAction = True
        ElseIf (e.Message = WM_OptionManual) Then
            System.Diagnostics.Debug.Print("AddinModule_OnSendMessage. WM_OptionManual")
            cancelAction = False
            Me.CommandBarsObj.GetType().InvokeMember("ExecuteMso", System.Reflection.BindingFlags.InvokeMethod, Nothing, Me.CommandBarsObj, New Object() {"CalculationOptionsManuallly"})
            CheckCalculationMode()
            cancelAction = True
        ElseIf (e.Message = WM_RibbonOptions) Then
            System.Diagnostics.Debug.Print("AddinModule_OnSendMessage. WM_RibbonOptions")
            cancelAction = False
            Me.CommandBarsObj.GetType().InvokeMember("ExecuteMso", System.Reflection.BindingFlags.InvokeMethod, Nothing, Me.CommandBarsObj, New Object() {"ApplicationOptionsDialog"})
            CheckCalculationMode()
            cancelAction = True
        ElseIf (e.Message = WM_CommandbarOptions) Then
            System.Diagnostics.Debug.Print("AddinModule_OnSendMessage. WM_CommandbarOptions")
            Dim cmBars As Office.CommandBars = CType(Me.CommandBarsObj, Office.CommandBars)
            Dim btnToolsOptions As Office.CommandBarButton = CType(cmBars.FindControl(Office.MsoControlType.msoControlButton, 522, Type.Missing, Type.Missing), Office.CommandBarButton)
            If (btnToolsOptions IsNot Nothing) Then
                cancelAction = False
                btnToolsOptions.Execute()
                CheckCalculationMode()
                cancelAction = True
                Marshal.ReleaseComObject(btnToolsOptions)
            End If
        End If
    End Sub

    Private Sub CheckCalculationMode()
        If currentCalculationMode Is Nothing Then
            System.Diagnostics.Debug.Print("Something goes wrong")
            Return
        End If
        If (ExcelApp.Calculation <> CType(currentCalculationMode, Excel.XlCalculation)) Then
            currentCalculationMode = ExcelApp.Calculation
            MessageBox.Show("Calculation mode has changed to " + currentCalculationMode.ToString())
        Else
            MessageBox.Show("CheckCalculationMode. ExcelApp.Calculation=" + ExcelApp.Calculation.ToString() + " currentCalculationMode=" + currentCalculationMode.ToString())
        End If
    End Sub
End Class

